


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""
    variable HelpTopic ""
    
    variable DoneFirmWare ""
    
    variable NUMLINKS
    set NUMLINKS 4      ;#  number of SPF links per PEXOR module
    
    variable NUMBOARDS
    set NUMBOARDS 10    ;#  number of  FEXEX4 modules supported per SPF link
    
    global ModuleMenu
    global LinkMenu  
    global BoardMenu 
    global ChannelMenu
    
    global FEBEXmodule
    global FEBEXlink
    global FEBEXboard
    global FEBEXchannel
    
    variable NumBoards   ;#  number of FEBEX modules active for the current SPF link
    set NumBoards 0
   
    variable AccessMode "Address"
    variable AddrBase 0x8000
    variable ADC 0

    variable RData 0
    variable ROffset 0
    variable WData 0
    variable WOffset 0
    variable SBData 0
    variable SBOffset 0
    variable CBData 0
    variable CBOffset 0
    
    variable RRData 0
    variable RWData 0
    
    variable Address 0
    variable Register "undefined"
    variable Channel 0
    
    
    for {set l 0} {$l < $NUMLINKS} {incr l} {
       for {set b 0} {$b < $NUMBOARDS} {incr b} {
           variable C[set l][set b]
       }
    }
    
    for {set l 0} {$l < $NUMLINKS} {incr l} {
       for {set b 0} {$b < $NUMBOARDS} {incr b} {
           set C[set l][set b] "orange"
       }
    }
    
    global RegList1
    global RegList2
    global RegList3

#    bus access procedures

    
    proc do_INIT {} {
        global Options
        global FEBEXlink
        global FEBEXboard
        variable NumBoards
        
        set NumBoards [set Options(FEBEX.Link[set FEBEXlink]NumBoards)]
 
        set rc [InitFEBEXRegister $FEBEXlink $NumBoards]
        
        puts "Initialise SPF link $FEBEXlink for $NumBoards boards => $rc"
        
        return $rc
    }
    
    proc do_PEXRESET {} {
        global FEBEXmodule
    
        set rc [ResetFEBEXRegister $FEBEXmodule]
        
        return $rc
    }
    
    proc do_FEBEXmodule {} {
        global FEBEXmodule
    
        set rc [DeviceFEBEXRegister $FEBEXmodule]
        
        InsertLog "module=$FEBEXmodule => $rc"
        
        return $rc
    }

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        global MIDAS_FEBEXAccessServer_Exists
        global MIDAS_FEBEXAccessClient_Exists
        
        global FEBEXmodule
        global FEBEXlink
        global FEBEXboard
        global FEBEXchannel
        
        variable AccessMode
        variable AddrBase
        variable ADC
        
        variable NumBoards
        
        variable RData
        variable ROffset
        variable WData
        variable WOffset
        variable SBData
        variable SBOffset
        variable CBData
        variable CBOffset
        
        variable RRData
        variable RWData
        
        variable Address
        variable DoneFirmWare 
        
       global ModuleMenu
       global LinkMenu
       global BoardMenu
       global ChannelMenu
        
     if {[info exists MIDAS_FEBEXAccessServer_Exists]} {InsertLog "FEBEXAccessServer Exists"} else {InsertLog "FEBEXAccessServer does not Exist"} 
     if {[info exists MIDAS_FEBEXAccessClient_Exists]} {InsertLog "FEBEXAccessClient Exists"} else {InsertLog "FEBEXAccessClient does not Exist"} 

        
     global FEBEXAccessServerHost
     if {![info exists FEBEXAccessServerHost]} {set FEBEXAccessServerHost $::FEBEX::FEBEXHost}
     global FEBEXAccessServerPort
     if {![info exists FEBEXAccessServerPort]} {set FEBEXAccessServerPort 8015}       
        
       InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
       InsertLog "FEBEXAccessServerHost = $FEBEXAccessServerHost"
       
       InsertLog "PEXOR Module = $FEBEXmodule; PEXOR link = $FEBEXlink; FEBEX Board = $FEBEXboard; FEBEX Channel = $FEBEXchannel; NumBoards = $NumBoards"
       InsertLog "Link Menu = $LinkMenu; Board Menu = $BoardMenu"
       InsertLog "AccessMode = $AccessMode; AddrBase = $AddrBase; ADC = $ADC"
       InsertLog "Address = [format 0x%08x $Address]"
       
       InsertLog "RData = $RData; ROffset = $ROffset"
       InsertLog "WData = $WData; WOffset = $WOffset"
       InsertLog "SBData = $SBData; SBOffset = $SBOffset"
       InsertLog "CBData = $CBData; CBOffset = $CBOffset"
       InsertLog "RRData = $RRData; RWData = $RWData"

       InsertLog "DoneFirmWare =  $DoneFirmWare"

#       set rc [catch {WriteFEBEXRegister $FEBEXlink $FEBEXboard TraceLength 256} m]
#       InsertLog "Write Trace Length => $rc $m"
#       set rc [catch {ReadFEBEXRegister $FEBEXlink $FEBEXboard TraceLength} m]
#       InsertLog "Read Trace Length => $rc $m"
       
       set rc [catch {ReadFEBEXRegister $FEBEXlink $FEBEXboard CompTime} m]
       if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}

       set DT "[format "%02u" [expr ($m >> 27) & 31]]/[format "%02u" [expr ($m >> 23) & 15]]/[format "%02u" [expr 2000 + (($m >> 17) & 63)]] [format "%02u" [expr ($m >> 12) & 31]]:[format "%02u" [expr ($m >> 6) & 63]]:[format "%02u" [expr $m & 63]]"   

       InsertLog "CompTime => $rc $RData $DT" 
 
       set DoneFirmWare $DT
       InsertLog "DoneFirmWare =  $DoneFirmWare"       
   }
   
   proc do_READ {}   {
        global FEBEXlink
        global FEBEXboard
        variable AccessMode
        variable AddrBase
        variable ADC
   
        variable RData
        variable ROffset
        
        if {$AccessMode == "Address"} {
            set rc [catch {ReadFEBEXRegister $FEBEXlink $FEBEXboard [format "0x%x" [expr $AddrBase+$ROffset]]} m]

        }
        if {$AccessMode == "ADC"} {
            set rc [catch {ReadFEBEXRegister $FEBEXlink $FEBEXboard [format "0x%x" [expr 0x008000 + ($ADC * 0x008000) + $ROffset]]} m]
        }
        
        InsertLog "do_READ =>  $rc  $m"
       
        if {$rc != 0} {InsertLog "READ returned $rc $m"; return}
        
        if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}
   }
   
   proc do_RREAD {}   {
        global RegList1
        global FEBEXlink
        global FEBEXboard
        global FEBEXchannel
        variable Register
   
        variable RRData

        if {[lsearch -exact $RegList1 $Register] == -1} {
            set rc [catch {ReadFEBEX4ARegister $FEBEXlink $FEBEXboard $FEBEXchannel $Register} m]
            InsertLog "do_RREAD $FEBEXlink $FEBEXboard $FEBEXchannel $Register =>  $rc  $m"
        } else {
            set rc [catch {ReadFEBEXRegister $FEBEXlink $FEBEXboard $Register} m]
            InsertLog "do_RREAD $FEBEXlink $FEBEXboard $Register =>  $rc  $m"
        }
 
        if {[llength $m] == 1} {set RRData $m} else {set RRData [lindex $m 1]}

        if {$rc != 0} {InsertLog "RREAD returned $rc $m"; return}
        
        if {[llength $m] == 1} {set RRData $m} else {set RRData [lindex $m 1]}
   }
   
   proc do_WRITE  {} {
        global FEBEXlink
        global FEBEXboard
        variable AccessMode
        variable AddrBase
   
        variable WData
        variable WOffset
        
        if {$AccessMode == "Address"} {
            set rc [catch {WriteFEBEXRegister $FEBEXlink $FEBEXboard [format "0x%x" [expr $AddrBase+$WOffset]] $WData} m]
            InsertLog "do_Write =>  $rc  $m"
        } else {
            InsertLog "Write is only available in Address mode"
        }
   }
   
   proc do_RWRITE  {} {
        global RegList1
        global FEBEXlink
        global FEBEXboard
        global FEBEXchannel
        variable Register
   
        variable RWData
        
        if {[lsearch -exact $RegList1 $Register] == -1} {
            set rc [catch {WriteFEBEX4ARegister $FEBEXlink $FEBEXboard $FEBEXchannel $Register $RWData} m]
            InsertLog "do_RWrite $FEBEXlink $FEBEXboard $FEBEXchannel $Register $RWData =>  $rc  $m"
        }  else {
            set rc [catch {WriteFEBEXRegister $FEBEXlink $FEBEXboard $Register $RWData} m] 
            InsertLog "do_RWrite $FEBEXlink $FEBEXboard $Register $RWData  =>  $rc  $m"
        }
        
        if {$rc != 0} {InsertLog "RWRITE returned $rc $m"; return}

   }
   
   proc do_SETBIT  {} {
        global FEBEXlink
        global FEBEXboard
        variable AccessMode
        variable AddrBase
   
        variable SBData
        variable SBOffset
        
        if {$AccessMode == "Address"} {
            set rc [catch {SetBitFEBEXRegister $FEBEXlink $FEBEXboard [format "0x%x" [expr $AddrBase+$SBOffset]] $SBData} m]
            InsertLog "do_SETBIT =>  $rc $m"
        } else {
            InsertLog "SetBit is only available in Address mode"
        }
    }
   
    proc do_CLEARBIT  {} {
        global FEBEXlink
        global FEBEXboard
        variable AccessMode
        variable AddrBase
   
        variable CBData
        variable CBOffset
        
        if {$AccessMode == "Address"} {
            set rc [catch {ClearBitFEBEXRegister $FEBEXlink $FEBEXboard [format "0x%x" [expr $AddrBase+$CBOffset]] $CBData} m]
            InsertLog "do_CLEARBIT =>  $rc $m"
        } else {
            InsertLog "ClearBit is only available in Address mode"
        }
   }
   
   proc do_HardWare {vl} {
     global Options
     global FEBEXlink
     global FEBEXboard
   
    set l [string range $vl 1 1]
    set b [string range $vl 2 2]
    
    set FEBEXlink $l
    
    variable C[set l][set b]
    
    if {[set C[set l][set b]] == "orange"} {set C[set l][set b] "green"; set FEBEXboard $b} else {set C[set l][set b] "orange"}
    
   }
   
    proc init_HardWare {} {
       global Options
       variable NUMLINKS
       variable NUMBOARDS
       
       for {set i 0} {$i < $NUMBOARDS} {incr i} {variable C[set i] 0}
       
      LoadOptions
    
      for {set l 0} {$l < $NUMLINKS} {incr l} {
         set num $Options(FEBEX.Link[set l]NumBoards)
         for {set b 0} {$b < $num} {incr b} {
           variable C[set l][set b]
           set C[set l][set b] "green"
         }
      }
    
    }
   
   proc update_HardWare {} {
       global Options
       global LinkMenu
       global FEBEXlink 
       global BoardMenu
       global FEBEXboard 
       variable NumBoards
       variable NUMLINKS
       variable NUMBOARDS
       
       for {set i 0} {$i < $NUMBOARDS} {incr i} {variable C[set i] 0}
       
    LoadOptions
    
    for {set l 0} {$l < $NUMLINKS} {incr l} {
       set NumBoards 0
       for {set b 0} {$b < $NUMBOARDS} {incr b} {
           variable C[set l][set b]
           if {[set C[set l][set b]] == "green"} {incr NumBoards}
       }
       set Options(FEBEX.Link[set l]NumBoards) $NumBoards
    }

    SaveOptions 

    set LinkMenu {}
    for {set l 0} {$l < $NUMLINKS} {incr l} {
        if {$Options(FEBEX.Link[set l]NumBoards) > 0} {lappend LinkMenu $l}
        WriteNetVar NetVar.DACQ.Link[set l]NumBoards $Options(FEBEX.Link[set l]NumBoards)
    }

    set l $FEBEXlink
    if {$Options(FEBEX.Link[set l]NumBoards) == 0} {set FEBEXlink [first $LinkMenu]}
    
    set BoardMenu {}
    set l $FEBEXlink
    for {set b 0} {$b < $NUMBOARDS} {incr b} {
       if {[set C[set l][set b]] == "green"} {lappend BoardMenu $b}
    }
    
    set b $FEBEXboard
    if {[set C[set l][set b]] != "green"} {set FEBEXboard [first $BoardMenu]}
   }
   

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable RData
       variable ROffset
       variable WData
       variable WOffset
       variable SBData
       variable SBOffset
       variable CBData
       variable CBOffset
       variable RWData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

		set w [lindex $cgidata 1]
		set vl [second [lindex $cgidata 1]]

               for {set i 2} {$i < [llength $cgidata]} {incr i} {
                   switch [lindex $cgidata $i]  {
                      ROffset  {incr i; set ROffset [lindex $cgidata $i]}
                      WOffset  {incr i; set WOffset [lindex $cgidata $i]}
                      SBOffset  {incr i; set SBOffset [lindex $cgidata $i]}
                      CBOffset  {incr i; set CBOffset [lindex $cgidata $i]}
                      WData    {incr i; set WData [lindex $cgidata $i]}
                      SBData    {incr i; set SBData [lindex $cgidata $i]}
                      CBData    {incr i; set CBData [lindex $cgidata $i]}
                      RWData   {incr i; set RWData [lindex $cgidata $i]}
                      default {}
                   }
               }

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   
		   HELP     {variable HelpTopic; set HelpTopic Help; do_help}

                   FEBEXBOARD   {global FEBEXboard; set FEBEXboard [lindex $w 1]}
                   FEBEXLINK    {global FEBEXlink; set FEBEXlink [lindex $w 1]}
                   FEBEXMODULE  {global FEBEXmodule; set FEBEXmodule [lindex $w 1]; do_FEBEXmodule}
                   FEBEXCHANNEL {global FEBEXchannel;set FEBEXchannel [lindex $w 1]}
                   
                   FEBEXADC  {variable ADC: set ADC [lindex $w 1]}
                   ADDRMODE  {variable AccessMode; set AccessMode [lindex $w 1]}
                   ADDRBASE  {variable AddrBase; set AddrBase [lindex $w 1]}
                   
                   REGISTER  {variable Register; set Register [lindex $w 1]}

                   READ     {do_READ}
                   WRITE    {do_WRITE}
                   SETBIT   {do_SETBIT}
                   CLEARBIT {do_CLEARBIT}
                   
                   RREAD    {do_RREAD}
                   RWRITE   {do_RWRITE}
                   
                   HardWare    {do_HardWare $vl}
                   
                   PEXRESET    {do_PEXRESET} 
                   INIT        {do_INIT}
                   LOAD        {LoadOptions}
                   SAVE        {SaveOptions}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
        }
      }
      
    init_HardWare

}   ;# end of if {$started == 0}

###    update_HardWare
#    export_HardWare

