
global env

   if {![namespace exists ::FEBEX]} {namespace eval ::FEBEX {puts "created namespace ::FEBEX"}}
   
   global ModuleList LinkList BoardList ChannelList
   
   if {![info exists ::FEBEX::module]} {set ::FEBEX::module [first $ModuleList]}
   if {![info exists ::FEBEX::link]} {set ::FEBEX::link [first $LinkList]}
   if {![info exists ::FEBEX::board]} {set ::FEBEX::board [first $BoardList]}
   if {![info exists ::FEBEX::channel]} {set ::FEBEX::channel [first $ChannelList]}

 #    set z [catch {source [file join $env(MIDASBASE) TclHttpd tcl Common febex.registerdefinitions]} m]

    global FEBEXAccessServerHost
    if {![info exists FEBEXAccessServerHost]} {set FEBEXAccessServerHost localhost}
    global FEBEXAccessServerPort
    if {![info exists FEBEXAccessServerPort]} {set FEBEXAccessServerPort 8015}
    
   if {![info exists ::FEBEX::FEBEXHost]} {set ::FEBEX::FEBEXHost localhost}

   if {![info exists ::FEBEX::TestMode]} {set rc [catch {set ::FEBEX::TestMode 0} m]}
   if {![info exists ::FEBEX::AccessTestMode]} {set rc [catch {set ::FEBEX::AccessTestMode 0} m]}
   
       set z [catch {source [file join $env(MIDASBASE) TclHttpd tcl Common febex.registerdefinitions]} m]
       if {$z != 0} {puts "febex.registerdefinitions > $m"}
   
    variable Unknown 0x78787878
   
    variable Rmsg ""
    variable Wmsg ""
    
    
#   read data word using  sfp, board amd memory offset

    proc SelectFEBEXModule {vl} {

      set z [catch {
          set ::FEBEX::module $vl
      } m]
          
      if {$z != 0} {InsertLog "SelectFEBEXModule => $m"}
    }

    proc SelectFEBEXLink {vl} {

      set z [catch {
          set ::FEBEX::link $vl
      } m]
          
      if {$z != 0} {InsertLog "SelectFEBEXLink => $m"}
    }
    
    proc SelectFEBEXBoard {vl} {set ::FEBEX::board $vl}
    proc SelectFEBEXChannel {vl} {set ::FEBEX::channel $vl}
    
    proc GetFEBEXModule {} {return $::FEBEX::module}
    proc GetFEBEXLink {} {return $::FEBEX::link}
    proc GetFEBEXBoard {} {return $::FEBEX::board}
    proc GetFEBEXChannel {} {return $::FEBEX::channel}

    proc ReadFEBEXRegister {Link Board Name}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

       switch -glob $Name {
       
           Test           {global REG_FEB_TEST; set Addr $REG_FEB_TEST}
           Version        {global REG_VERSION; set Addr $REG_VERSION}
           LED            {global REG_LED; set Addr $REG_LED}
           BUF0           {global REG_BUF0; set Addr $REG_BUF0}     
           BUF1           {global REG_BUF1; set Addr $REG_BUF1}     
           MODID          {global REG_MODID; set Addr $REG_MODID}     
           HEADER         {global REG_HEADER; set Addr $REG_HEADER}     
           FOOTER         {global REG_FOOTER; set Addr $REG_FOOTER}     
           DATALEN        {global REG_DATA_LEN; set Addr $REG_DATA_LEN}    
           BUF0_DATA_LEN  {global REG_BUF0_DATA_LEN; set Addr $REG_BUF0_DATA_LEN}     
           BUF1_DATA_LEN  {global REG_BUF1_DATA_LEN; set Addr $REG_BUF1_DATA_LEN}  
           SUBMEM_NUM     {global REG_SUBMEM_NUM; set Addr $REG_SUBMEM_NUM}
           SUBMEM_OFF     {global REG_SUBMEM_OFF; set Addr $REG_SUBMEM_OFF}     
           Ctrl           {global REG_CTRL; set Addr $REG_CTRL}
           TraceLength    {global REG_FEB_TRACE_LEN; set Addr $REG_FEB_TRACE_LEN}
           TrigDelay      {global REG_FEB_TRIG_DELAY; set Addr $REG_FEB_TRIG_DELAY}
           SPI            {global REG_FEB_SPI; set Addr $REG_FEB_SPI}
           ChDisable      {global REG_MEM_DISABLE; set Addr $REG_MEM_DISABLE}
           ChDataReduction {global REG_DATA_REDUCTION; set Addr $REG_DATA_REDUCTION}
           ChMemDisable   {global REG_MEM_DISABLE; set Addr $REG_MEM_DISABLE}
           CompTime       {global REG_COMP_DATE; set Addr $REG_COMP_DATE}
           0x*            {set Addr $Name}
           
           default        {variable Unknown; set Addr $Unknown}
       }
       
# puts "ReadFEBEXRegister Name=$Name  Address=[format \"0x%x\" $Addr]"


  if {$::FEBEX::TestMode != 0} {
     variable ::FEBEX::FEBEXData
     if {![info exists ::FEBEX::FEBEXData($Link,$Board,$Addr)]} {set ::FEBEX::FEBEXData($Link,$Board,$Addr) 0xaaaa} 
     return [set ::FEBEX::FEBEXData($Link,$Board,$Addr)]
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "ReadFEBEXRegister do_Read"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Read $Link $Board $Addr} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "ReadFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "ReadFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__Read"
            set rc [catch {FEBEXAccessClient__Read $Link $Board $Addr} m]
        }
        if {$rc != 0} {
            InsertLog "Read returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ReadFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
           InsertLog "ReadFEBEXRegister: $Link $Board $Name  Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }
    
#    write data word using  sfp, board, memory offset and data word

    proc WriteFEBEXRegister {Link Board Name Vl}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

       switch -glob $Name {

           Test           {global REG_FEB_TEST; set Addr $REG_FEB_TEST}
           Reset          {global REG_RST; set Addr $REG_RST}
           TimeReset      {global REG_FEB_RST; set Addr $REG_FEB_RST}
           LED            {global REG_LED; set Addr $REG_LED}
           BUF0           {global REG_BUF0; set Addr $REG_BUF0}     
           BUF1           {global REG_BUF1; set Addr $REG_BUF1}     
           MODID          {global REG_MODID; set Addr $REG_MODID}     
           HEADER         {global REG_HEADER; set Addr $REG_HEADER}     
           FOOTER         {global REG_FOOTER; set Addr $REG_FOOTER}     
           DATALEN        {global REG_DATA_LEN; set Addr $REG_DATA_LEN}    
           BUF0_DATA_LEN  {global REG_BUF0_DATA_LEN; set Addr $REG_BUF0_DATA_LEN}     
           BUF1_DATA_LEN  {global REG_BUF1_DATA_LEN; set Addr $REG_BUF1_DATA_LEN}  
           SUBMEM_NUM     {global REG_SUBMEM_NUM; set Addr $REG_SUBMEM_NUM}
           SUBMEM_OFF     {global REG_SUBMEM_OFF; set Addr $REG_SUBMEM_OFF}     
           Ctrl           {global REG_CTRL; set Addr $REG_CTRL}
           TraceLength    {global REG_FEB_TRACE_LEN; set Addr $REG_FEB_TRACE_LEN}
           TrigDelay      {global REG_FEB_TRIG_DELAY; set Addr $REG_FEB_TRIG_DELAY}
           SPI            {global REG_FEB_SPI; set Addr $REG_FEB_SPI}
           ChDisable      {global REG_MEM_DISABLE; set Addr $REG_MEM_DISABLE}
           ChDataReduction {global REG_DATA_REDUCTION; set Addr $REG_DATA_REDUCTION}
           ChMemDisable   {global REG_MEM_DISABLE; set Addr $REG_MEM_DISABLE}
           0x*            {set Addr $Name}
           
           default        {variable Unknown; set Addr $Unknown}
       }
       
# puts "WriteFEBEXRegister Name=$Name Address=[format \"0x%x\" $Addr]  Vl=[format \"0x%x\" $Vl]"

  if {$::FEBEX::TestMode != 0} {
     variable ::FEBEX::FEBEXData
     set ::FEBEX::FEBEXData($Link,$Board,$Addr) $Vl
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "WriteFEBEXRegister do_Write"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Write $Link $Board $Addr $Vl} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "WriteFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "WriteFEBEXRegister FEBEXAccessClient__Write"
            set rc [catch {FEBEXAccessClient__Write $Link $Board $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "Write returned with an error\n$m\n$errorCode\n$errorInfo"
            puts "WriteFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Write $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "WriteFEBEXRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }
    
#    Access to FEBEX4A firmware by James Lawson
#    only selected registers are Channel dependant


   proc ReadFEBEX4ARegister {Link Board Channel Name}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost
        
       global REG_CFD
       global REG_EXBY
       global REG_TM
       global REG_MWD
       
       set Data 0
        
       switch -glob $Name {

           cfd_enable     {global CFD_ENABLE; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_ENABLE << 24) + ($Channel << 16) + $Data]]}
           cfd_thresh     {global CFD_THRESH; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_THRESH << 24) + ($Channel << 16) + $Data]]}
           cfd_direction  {global CFD_DIR; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_DIR << 24) + ($Channel << 16) + $Data]]}
           cfd_mode       {global CFD_MODE; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_MODE << 24) + ($Channel << 16) + $Data]]}
           cfd_delay      {global CFD_DELAY; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_DELAY << 24) + ($Channel << 16) + $Data]]}
           cfd_filt_thresh {global CFD_FILT_THRESH; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_FILT_THRESH << 24 + ($Channel << 16)) + $Data]]}
           cfd_mavg       {global CFD_MAVG; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_MAVG << 24) + ($Channel << 16) + $Data]]}

           expld_mode     {global EXPLD_MODE; set Addr $REG_EXBY; set Vl [format "0x%x" [expr ($EXPLD_MODE << 24) + ($Channel << 16) + $Data]]}
           expld_cfdfwd   {global EXPLD_CFDFWD; set Addr $REG_EXBY; set Vl [format "0x%x" [expr ($EXPLD_CFDFWD << 24) + ($Channel << 16) + $Data]]}
           
           tm_row         {global TM_ROW; set Addr $REG_TM; set Vl [format "0x%x" [expr ($TM_ROW << 24) + ($Channel << 16) + $Data]]}
           tm_window      {global TM_WINDOW; set Addr $REG_TM; set Vl [format "0x%x" [expr ($TM_WINDOW << 24) + ($Channel << 16) + $Data]]}
           
           mwd_m          {global MWD_M; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_M << 24) + ($Channel << 16) + $Data]]}
           mwd_l          {global MWD_L; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_L << 24) + ($Channel << 16) + $Data]]}
           mwd_t          {global MWD_T; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_T << 24) + ($Channel << 16) + $Data]]}
           mwd_b          {global MWD_B; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_B << 24) + ($Channel << 16) + $Data]]}
           mwd_o          {global MWD_O; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_O << 24) + ($Channel << 16) + $Data]]}
           mwd_ctd        {global MWD_CTD; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_CTD << 24) + ($Channel << 16) + $Data]]}
           
           0x*            {set Addr $Name}
           default        {variable Unknown; set Addr $Unknown; set Vl 0x6677}
       }

# puts "ReadFEBEX4ARegister  Name=$Name  Address=[format \"0x%x\" $Addr]  Vl=[format \"0x%x\" $Vl]  "
 
  if {$::FEBEX::TestMode != 0} {
     variable ::FEBEX::FEBEXData
     if {![info exists ::FEBEX::FEBEXData($Link,$Board,$Channel,$Name)]} {set ::FEBEX::FEBEXData($Link,$Board,$Channel,$Name) 0xaaaa} 
     puts "[set ::FEBEX::FEBEXData($Link,$Board,$Channel,$Name)]"
     return [set ::FEBEX::FEBEXData($Link,$Board,$Channel,$Name)]
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "ReadFEBEXRegister do_Read"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Write $Link $Board $Addr [expr ($Vl & 0x0f000000) + 0x80000000]} m]
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Read $Link $Board $Addr} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "ReadFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "ReadFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__Read"
            set rc [catch {FEBEXAccessClient__Write $Link $Board [format "0x%x" [expr $Addr + 0x80000000]] $Vl} m]
            set rc [catch {FEBEXAccessClient__Read $Link $Board $Addr} m]
        }
        if {$rc != 0} {
            InsertLog "Read returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ReadFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
           InsertLog "ReadFEBEX4ARegister $Link $Board $Channel $Name  Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"      
#  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}
            return $RData
        }
    }
    
#    write data word using  sfp, board, memory offset and data word

#    Access to FEBEX4A firmware by James Lawson
#    only selected registers are Channel dependant

    proc WriteFEBEX4ARegister {Link Board Channel Name Data}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost
        
        global REG_CFD
        global REG_EXBY
        global REG_TM
        global REG_MWD
        
       switch -glob $Name {
       
           cfd_enable     {global CFD_ENABLE; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_ENABLE << 24) + ($Channel << 16) + $Data]]}
           cfd_thresh     {global CFD_THRESH; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_THRESH << 24) + ($Channel << 16) + $Data]]}
           cfd_direction  {global CFD_DIR; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_DIR << 24) + ($Channel << 16) + $Data]]}
           cfd_mode       {global CFD_MODE; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_MODE << 24) + ($Channel << 16) + $Data]]}
           cfd_delay      {global CFD_DELAY; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_DELAY << 24) + ($Channel << 16) + $Data]]}
           cfd_filt_thresh {global CFD_FILT_THRESH; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_FILT_THRESH << 24) + ($Channel << 16) + $Data]]}
           cfd_mavg       {global CFD_MAVG; set Addr $REG_CFD; set Vl [format "0x%x" [expr ($CFD_MAVG << 24) + ($Channel << 16) + $Data]]}

           expld_mode     {global EXPLD_MODE; set Addr $REG_EXBY; set Vl [format "0x%x" [expr ($EXPLD_MODE << 24) + ($Channel << 16) + $Data]]}
           expld_cfdfwd   {global EXPLD_CFDFWD; set Addr $REG_EXBY; set Vl [format "0x%x" [expr ($EXPLD_CFDFWD << 24) + ($Channel << 16) + $Data]]}
           
           tm_row         {global TM_ROW; set Addr $REG_TM; set Vl [format "0x%x" [expr ($TM_ROW << 24) + ($Channel << 16) + $Data]]}
           tm_window      {global TM_WINDOW; set Addr $REG_TM; set Vl [format "0x%x" [expr ($TM_WINDOW << 24) + ($Channel << 16) + $Data]]}
          
           mwd_m          {global MWD_M; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_M << 24) + ($Channel << 16) + $Data]]}
           mwd_l          {global MWD_L; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_L << 24) + ($Channel << 16) + $Data]]}
           mwd_t          {global MWD_T; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_T << 24) + ($Channel << 16) + $Data]]}
           mwd_b          {global MWD_B; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_B << 24) + ($Channel << 16) + $Data]]}
           mwd_o          {global MWD_O; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_O << 24) + ($Channel << 16) + $Data]]}
           mwd_ctd        {global MWD_CTD; set Addr $REG_MWD; set Vl [format "0x%x" [expr ($MWD_CTD << 24) + ($Channel << 16) + $Data]]}

           0x*            {set Addr $Name}
           default        {variable Unknown; set Addr $Unknown; set Vl 0x7766}
       }
       
# puts "WriteFEBEX4ARegister  Name=$Name  Address=[format \"0x%x\" $Addr]  data=[format \"0x%x\" $Data] $Vl"

  if {$::FEBEX::TestMode != 0} {
     variable ::FEBEX::FEBEXData
     set ::FEBEX::FEBEXData($Link,$Board,$Channel,$Name) $Data
     return 0
  }
  

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "WriteFEBEXRegister do_Write"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Write $Link $Board $Addr $Vl} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "WriteFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "WriteFEBEXRegister FEBEXAccessClient__Write"
            set rc [catch {FEBEXAccessClient__Write $Link $Board $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "Write returned with an error\n$m\n$errorCode\n$errorInfo"
            puts "WriteFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Write $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "WriteFEBEXRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }
    
#    initialise chain at sfp for Boards number of boards

    proc InitFEBEXRegister {Link Boards}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

# puts "InitFEBEXRegister"

  if {$::FEBEX::TestMode != 0} {
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "InitFEBEXRegister do_Init"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Init $Link $Boards} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "InitFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "InitFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__Init"
            set rc [catch {FEBEXAccessClient__Init $Link $Boards} m]
        }
        if {$rc != 0} {
            InsertLog "Init returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "InitFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#           InsertLog "Init => $m [format \"0x%x\" $m]"
#  puts "Init => $m [format \"0x%x\" $m]"
            return $m
        }
    }
    
#    Set the pex device number  (default = 0  =>   /dev/pexor/0)

    proc SetupFEBEXRegister {Module}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

# puts "SetupFEBEXRegister"

  if {$::FEBEX::TestMode != 0} {
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "SetupFEBEXRegister do_Init"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Device $Module} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "SetupFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "SetupFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__Device"
            set rc [catch {FEBEXAccessClient__Device $Module} m]
        }
        if {$rc != 0} {
            InsertLog "Module returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "SetupFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#           InsertLog "Module => $m [format \"0x%x\" $m]"
#  puts "SetupFEBEXRegister: Module => $m [format \"0x%x\" $m]"
            return $m
        }
    }
    
#    reset dma and sfp engines
    
    proc ResetFEBEXRegister {Module}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

# puts "ResetFEBEXRegister"

  if {$::FEBEX::TestMode != 0} {
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "ResetFEBEXRegister do_Reset"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Reset $Module} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "ResetFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "ResetFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__Module"
            set rc [catch {FEBEXAccessClient__Reset $Module} m]
        }
        if {$rc != 0} {
            InsertLog "Reset returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ResetFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return $m
        } else {
#           InsertLog "Reset => $m [format \"0x%x\" $m]"
#  puts "Reset => $m [format \"0x%x\" $m]"
            return $m
        }
    } 
    

#    set bits in the register at Link, Board and memory offset defined by the bit patterm Vl

    proc SetBitFEBEXRegister {Link Board Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

# puts "SetBitFEBEXRegister"

  if {$::FEBEX::TestMode != 0} {
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "SetBitFEBEXRegister do_SetBit"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_SetBit $Link $Board $Addr $Vl} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "InitFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "SetBitFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__SetBit"
            set rc [catch {FEBEXAccessClient__SetBit $Link $Board $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "SetBit returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "SetBitFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "SetBit $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "SetBitFEBEXRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }
    
    
#    clear bits in the register at Link, Board and memory offset defined by the bit patterm Vl
    
    proc ClearBitFEBEXRegister {Link Board Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

# puts "ClearBitFEBEXRegister"

  if {$::FEBEX::TestMode != 0} {
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "ClearBitFEBEXRegister do_ClearBit"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_ClearBit $Link $Board $Addr $Vl} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "ClearBitFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "ClearBitFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__ClearBit"
            set rc [catch {FEBEXAccessClient__ClearBit $Link $Board $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "ClearBit returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ClearBitFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "ClearBit $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "ClearBitFEBEXRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }
    
#    configure the pexor device using the contents of File

     proc ConfigureFEBEXRegister {File}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

# puts "ConfigureFEBEXRegister"

  if {$::FEBEX::TestMode != 0} {
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "ConfigureFEBEXRegister do_Configure"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Configure $File} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "ConfigureFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "ConfigureFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__Configure"
            set rc [catch {FEBEXAccessClient__Configure $File} m]
        }
        if {$rc != 0} {
            InsertLog "Configure returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ConfigureFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#           InsertLog "Configure => $m [format \"0x%x\" $m]"
#  puts "Configure => $m [format \"0x%x\" $m]"
            return $m
        }
    }   
    

#    verify the configuration for pexor device against the contents of File
    
        proc VerifyFEBEXRegister {File}  {
        global errorCode errorInfo
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost

# puts "VerifyFEBEXRegister"

  if {$::FEBEX::TestMode != 0} {
     return 0
  }

        if {[info exists MIDAS_FEBEXAccessServer_Exists]} {
# puts "VerifyFEBEXRegister do_Verify"
            set rc [catch {interp eval "" ::namespace inscope ::urn:FEBEXAccessServer do_Verify $File} m]
        } else {
            if {$FEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set FEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "VerifyFEBEXRegister configure $FEBEXAccessServerHost"
                FEBEXAccessClient_Configure
            }
# puts "VerifyFEBEXRegister  $FEBEXAccessServerHost  FEBEXAccessClient__Verify"
            set rc [catch {FEBEXAccessClient__Verify $File} m]
        }
        if {$rc != 0} {
            InsertLog "Verify returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "VerifyFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#           InsertLog "Verify => $m [format \"0x%x\" $m]"
#  puts "Verify => $m [format \"0x%x\" $m]"
            return $m
        }
    }   
    
    
    
